/*
DivAgain, un robot para RealTimeBattle
Copyright (C) 2003  Dives

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

//#ifdef TIME_WITH_SYS_TIME 
//# include <sys/time.h>
//# include <time.h>
//#else
//# if HAVE_SYS_TIME_H
//#  include <sys/time.h>
//# else
//#  include <time.h>
//# endif
//#endif

#include "dives.hh"

using namespace std;

/*
 * Pasa del mensaje de texto al tipo de mensaje
 */
message_to_robot_type name2msg_to_robot_type(char* msg_name)
{
	for (int i=0; message_to_robot[i].msg[0] != '\0'; i++)
	{
		if (strcmp(message_to_robot[i].msg, msg_name) == 0)
			return (message_to_robot_type)i;
	}
	return UNKNOWN_MESSAGE_TO_ROBOT;
}

/*
 * Determina el mensaje que llega
 */
void checkMessages(int sig)
{
	char msg_name[81];
	char text[81];
	message_to_robot_type msg_t;

	/*timeval current_time;
	gettimeofday(&current_time, NULL);
	srand(current_time.tv_usec);*/

	cin.clear();
	while (!cin.eof())
	{
		cin >> msg_name;
		msg_t = name2msg_to_robot_type(msg_name);
		switch(msg_t)
		{
			case INITIALIZE:
				int init;
				cin >> init ;
				initialize( init );
				break;

			case GAME_STARTS:
				gameStarts();
				break;

			case GAME_FINISHES:
				gameFinishes();
				break;

			case INFO:
				double tiempo, velocidad, angulo;
				cin >> tiempo >> velocidad  >> angulo;
				info( tiempo, velocidad, angulo );
				break;

			case ROBOTS_LEFT:
				int robotsQuedan;
				cin >> robotsQuedan;
				robotsLeft( robotsQuedan );
				break;

			case RADAR:
			{
				double distancia, angulo;
				int objeto;

				cin >> distancia >> objeto >> angulo;
				switch(objeto)
				{
					case ROBOT:
						radarRobot( distancia, angulo );
						break;
					case WALL:
						radarWall( distancia, angulo );
						break;
					case SHOT:
						radarShot( distancia, angulo );
						break;
					case COOKIE:
						radarCookie( distancia, angulo );
						break;
					case MINE:
						radarMine( distancia, angulo );
						break;
				}
				break;
			}

			case COLLISION:
			{
				int objeto;
				double angulo;
				cin >> objeto >> angulo;
				switch(objeto)
				{
					case ROBOT:
						collisionRobot( angulo );
						break;
					case WALL:
						collisionWall( angulo );
						break;
					case SHOT:
						collisionShot( angulo );
						break;
					case COOKIE:
						collisionCookie( angulo ); 
						break;
					case MINE:
						collisionMine( angulo ); 
						break;
				}
			}
			break;

			case WARNING:
				int type;
				char text[81];
				cin >> type;
				cin.getline(text, 80, '\n');
				warning( type, text );
				break;

			case EXIT_ROBOT:
				exitRobot();
				break;

			case YOUR_NAME:
				char nombre[81];
				cin >> nombre;
				yourName( nombre );
				break;

			case YOUR_COLOUR:
				char color[81];
				cin >> color;
				yourColour( color );
				break;

			case GAME_OPTION:
				int nr;
				double valor;
				cin >> nr >> valor;
				gameOption( nr, valor );
				break;

			case COORDINATES:
				double x, y, rotacion;
				cin >> x >> y >> rotacion;
				coordinates( x, y, rotacion );
				break;

			case ROBOT_INFO:
				double energiaEnemigo;
				int enemigo;
				cin >> energiaEnemigo >> enemigo;
				robotInfo( energiaEnemigo, enemigo );
				break;

			case ROTATION_REACHED:
				int que;
				cin >> que;
				rotationReached( que );
				break;

			case ENERGY:
				double energia;
				cin >> energia;
				energy( energia );
				break;

			case DEAD:
				dead();
				break;

			default:
				break;
		}
	}
	signal (sig, checkMessages);
}

/*
 * Programa principal
 */
int main(int argc, char * argv[])
{
	sigset_t usr1set;

	signal(SIGUSR1, checkMessages);
	signal(SIGALRM, handle_alarm);

	// libpthread seems to block USR1 sometimes for some reason
	sigemptyset(&usr1set);
	sigaddset(&usr1set, SIGUSR1);
	sigprocmask(SIG_UNBLOCK, &usr1set, NULL);

	robotOption(SIGNAL, SIGUSR1);
	robotOption(SEND_ROTATION_REACHED, 2); // 0- nada
														// 1-rotateTo || rotateAmount
														// 2-como 1 + sweep*/
	
	for (;;sleep(1));
	
	return (EXIT_SUCCESS);
}
